/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2009  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
using Db4oUnit;
using Db4objects.Db4o;
using Db4objects.Db4o.Config;
using Db4objects.Db4o.IO;
using Db4objects.Db4o.Internal.CS;
using Sharpen.Lang;

namespace Db4objects.Db4o.Tests.Common.CS
{
	public class ServerTransactionCountTestCase : ITestCase
	{
		private const int Timeout = 100;

		/// <exception cref="System.Exception"></exception>
		public virtual void Test()
		{
			IConfiguration config = Db4oFactory.NewConfiguration();
			config.ClientServer().TimeoutServerSocket(Timeout);
			config.Io(new MemoryIoAdapter());
			ObjectServerImpl server = (ObjectServerImpl)Db4oFactory.OpenServer(config, string.Empty
				, -1);
			Thread.Sleep(Timeout * 2);
			Assert.AreEqual(0, server.TransactionCount());
			server.Close();
		}
	}
}
