/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2009  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
using Db4objects.Db4o.Config;
using Sharpen.Net;

namespace Db4objects.Db4o.Config
{
	/// <summary>Create raw platform native sockets.</summary>
	/// <remarks>Create raw platform native sockets.</remarks>
	public class PlainSocketFactory : INativeSocketFactory
	{
		/// <exception cref="System.IO.IOException"></exception>
		public virtual ServerSocket CreateServerSocket(int port)
		{
			return new ServerSocket(port);
		}

		/// <exception cref="System.IO.IOException"></exception>
		public virtual Sharpen.Net.Socket CreateSocket(string hostName, int port)
		{
			return new Sharpen.Net.Socket(hostName, port);
		}

		public virtual object DeepClone(object context)
		{
			return this;
		}
	}
}
