/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2009  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
using Db4objects.Db4o.Internal;

namespace Db4objects.Db4o.Internal.Classindex
{
	/// <summary>client class index.</summary>
	/// <remarks>
	/// client class index. Largly intended to do nothing or
	/// redirect functionality to the server.
	/// </remarks>
	internal sealed class ClassIndexClient : Db4objects.Db4o.Internal.Classindex.ClassIndex
	{
		internal ClassIndexClient(ClassMetadata aYapClass) : base(aYapClass)
		{
		}

		public override void Add(int a_id)
		{
			throw Exceptions4.VirtualException();
		}

		internal void EnsureActive()
		{
		}

		// do nothing
		public override void Read(Transaction a_trans)
		{
		}

		// do nothing
		internal override void SetDirty(ObjectContainerBase a_stream)
		{
		}

		// do nothing
		public sealed override void WriteOwnID(Transaction trans, ByteArrayBuffer a_writer
			)
		{
			a_writer.WriteInt(0);
		}
	}
}
