/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2009  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
using Db4objects.Db4o.Reflect;

namespace Db4objects.Db4o.Reflect
{
	/// <summary>Useful as "out" or "by ref" function parameter.</summary>
	/// <remarks>Useful as "out" or "by ref" function parameter.</remarks>
	public sealed class ReflectClassByRef
	{
		/// <summary>Useful whenever an "out" parameter is to be ignored.</summary>
		/// <remarks>Useful whenever an "out" parameter is to be ignored.</remarks>
		public static readonly Db4objects.Db4o.Reflect.ReflectClassByRef Ignored = new Db4objects.Db4o.Reflect.ReflectClassByRef
			();

		public IReflectClass value;

		public ReflectClassByRef(IReflectClass initialValue)
		{
			value = initialValue;
		}

		public ReflectClassByRef()
		{
		}
	}
}
